# Letterpaw Soap Service

## Daftar Isi
- [Letterpaw Soap Service](#letterpaw-soap-service)
  - [Daftar Isi](#daftar-isi)
  - [Deskripsi Proyek](#deskripsi-proyek)
  - [Daftar Fitur SOAP](#daftar-fitur-soap)
  - [Technologies used](#technologies-used)
  - [Cara Instalasi](#cara-instalasi)
  - [Cara Menjalankan Aplikasi](#cara-menjalankan-aplikasi)
  - [Database Schema](#database-schema)
  - [Pembagian Tugas](#pembagian-tugas)
  - [*Completed Bonus*](#completed-bonus)


## Deskripsi Proyek

SOAP (Simple Object Access Protocol) dibuat menggunakan bahasa Java untuk service yang digunakan oleh proyek letterpaw

`
Disusun untuk memenuhi Tugas Besar IF3110 Pengembangan Aplikasi Berbasis Web Milestone 2
`

**Letterpaw** adalah sebuah platform sosial yang dirancang khusus untuk pecinta film. Platform ini memungkinkan pengguna untuk membuat memilih film yang mereka telah tonton, memberikan peringkat, dan menulis ulasan tentang film tersebut.

## Daftar Fitur SOAP
- User dapat mendaftar untuk menjadi premium user
- User dapat membatalkan pendaftaran premium
- User dapat melihat status premiumnya
- Admin dapat melihat seluruh daftar permintaan premium 
- Admin dapat menerima atau menolak permintaan premium user
- Admin dapat melihat seluruh daftar user premium

## Technologies used
- Jax-WS
- JDBC
- Sun HTTP
- json
- apache http client
- Jakarta Mail

## Cara Instalasi

1. Lakukan pengunduhan repository ini dengan menggunakan perintah git clone https://gitlab.informatika.org/if3110-2023-k02-02-02/soap-service.git pada terminal komputer Anda.
2. Pastikan komputer Anda telah menginstalasi dan menjalankan aplikasi Docker.
3. Lakukan pembuatan image Docker yang akan digunakan oleh aplikasi ini dengan menjalankan perintah docker build. pada terminal directory aplikasi web.
4. Buatlah sebuah file .env yang bersesuaian dengan penggunaan (contoh file tersebut dapat dilihat pada .env.example).

## Cara Menjalankan Aplikasi

1. Untuk melakukan build aplikasi pertama kali, lakukan
`
docker-compose up --build -d
`

2. Jika sudah pernah melakukan build aplikasi, lakukan
`
docker-compose up -d
`

3. Akses service pada http://localhost:7000/userpremiumservice?wsdl
4. `docker-compose down` untuk mematikan aplikasi 


## Database Schema

![Database Schema](/docs/images/schema.png)

## Pembagian Tugas

| Fitur           | NIM      |
| --------------- | -------- |
| registerPremium | 13521089 |
| cancelRegister  | 13521089 |
| checkStatus     | 13518110 |
| getAllPremium   | 13521089 |
| getAllPending   | 13521094 |
| approvePremium  | 13521089 |
| rejectPremium   | 13521084 |
| Logging         | 13521089 |
| Authentication  | 13521089 |
| Mail            | 13521089 |
| Model           | 13521089 |
| Request         | 13521089 |
| Docker          | 13521089 |

## *Completed Bonus*
1. Mailer

![Mailer](docs/images/mailer.png)

2. Docker