package com.letterpaw.soap;

import com.letterpaw.soap.database.DatabaseConfig;
import com.letterpaw.soap.database.model.Logging;
import com.letterpaw.soap.database.model.UserPremium;
import com.letterpaw.soap.publisher.UserPremiumServicePublisher;

import javax.xml.ws.Endpoint;

public class Main {
    public static void main(String[] args) {
        try {
            DatabaseConfig.getInstance();
            Logging.init();
            UserPremium.init();
            UserPremiumServicePublisher userPremiumServicePublisher = new UserPremiumServicePublisher();
            userPremiumServicePublisher.publish();
            System.out.println("Server is starting");
        } catch(Exception e) {
            System.out.println("Something's wrong! " + e.getMessage());
        }
    }
}
