package com.letterpaw.soap.database;

import io.github.cdimascio.dotenv.Dotenv;

import java.sql.*;

public final class DatabaseConfig {
  static Dotenv dotenv = Dotenv.configure()
          .ignoreIfMissing()
          .load();
  static final String DB_HOST = dotenv.get("DB_HOST", "localhost");
  static final String DB_PORT = dotenv.get("DB_PORT", "3306");
  static final String DB_NAME = dotenv.get("DB_NAME", "letterpaw_soap");
  static final String DB_USER = dotenv.get("DB_USER", "soap_user");
  static final String DB_PASS = dotenv.get("DB_PASS", "p4ssw0rd");
  static final String DB_URL = dotenv.get("DB_URL", "jdbc:mysql://" + DB_HOST + ":" + DB_PORT + "/" + DB_NAME);

  static Connection conn;
  static DatabaseConfig client;

  private static Connection getConnection() {
    try {
      conn = DriverManager.getConnection(DB_URL, DB_USER, DB_PASS);
      System.out.println("get db connection success");
      System.out.println(DB_URL);
      return conn;
    } catch (Exception e) {
      e.printStackTrace();
      System.out.println(DB_URL);
      throw new RuntimeException("Error initializing database connection", e);

    }
  }

  public static DatabaseConfig getInstance() {
    if (client == null) {
      client = new DatabaseConfig();
      try {
        Class.forName("com.mysql.cj.jdbc.Driver");
      } catch(Exception e) {
        e.printStackTrace();
      }
      System.out.println("initialize db");
    }
    return client;
  }

  public void runExecute(String sql) throws SQLException {
    try {
      Statement stmt = getConnection().createStatement();
      stmt.execute(sql);
      stmt.getConnection().close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  public PreparedStatement prep(String sql) throws SQLException {
    return getConnection().prepareStatement(sql);
  }

  public PreparedStatement prep(String sql, boolean auto_increment) throws SQLException {
    return getConnection().prepareStatement(sql, Statement.RETURN_GENERATED_KEYS);
  }
}

