package com.letterpaw.soap.service;

import com.letterpaw.soap.database.model.UserPremium;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import java.sql.SQLException;
import java.util.List;

@WebService
public interface UserPremiumService {

    @WebMethod(operationName = "registerPremium")
    @WebResult(name = "premiumRequest")
    public String registerPremium(@WebParam(name = "userId") int userId, @WebParam(name = "email") String email) throws SQLException;

    @WebMethod(operationName = "checkStatus")
    @WebResult(name = "userStatus")
    public String checkStatus(@WebParam(name = "userId") int userId) throws SQLException;

    @WebMethod(operationName = "cancelRegister")
    @WebResult(name = "responseCancel")
    public String cancelRegister(@WebParam(name = "userId") int userId) throws SQLException;

    @WebMethod(operationName = "approvePremium")
    @WebResult(name = "approvalResponse")
    public String approvePremium(@WebParam(name = "userId") int userId) throws SQLException;

    @WebMethod(operationName = "rejectPremium")
    @WebResult(name = "rejectionResponse")
    public String rejectPremium(@WebParam(name = "userId") int userId) throws SQLException;

    @WebMethod(operationName = "getAllPremium")
    @WebResult(name = "listUserPremium")
    public List<UserPremium> getAllPremium() throws SQLException;

    @WebMethod(operationName = "getAllPending")
    @WebResult(name = "listUserPending")
    public List<UserPremium> getAllPending() throws SQLException;
}
