package com.letterpaw.soap.util;

import com.letterpaw.soap.enums.ServiceType;
import io.github.cdimascio.dotenv.Dotenv;

import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;
import java.util.List;
import java.util.Map;

public class Auth {

    static Dotenv dotenv = Dotenv.configure().ignoreIfMissing().load();
    public static final String RESTAPIKey = dotenv.get("REST_API_KEY", "DefaultRESTAPIKey");
    public static final String PHPAPIKey = dotenv.get("PHP_API_KEY", "DefaultPHPAPIKey");

    public static boolean IsAuthenticated(WebServiceContext ctx, ServiceType type) {
        @SuppressWarnings("unchecked")
        // Check the request with the API Key
        // Check if the service is authenticated or not, message context is used to get
        // HTTP request headers, which contains the key,
        // which is then compared with the actual key
        Map<String, List<String>> headers = (Map<String, List<String>>) ctx.getMessageContext()
                .get(MessageContext.HTTP_REQUEST_HEADERS);
        // Get header for authorization
        List<String> auth = headers.get("authorization");
        String key = "";
        // Get the stored key
        if (type == ServiceType.REST) {
            key = RESTAPIKey;
        } else if (type == ServiceType.PHP) {
            key = PHPAPIKey;
        }
        // System.out.println(auth.get(0));
        // System.out.println(key);
        // System.out.println(!auth.isEmpty() && auth.get(0).equals("Bearer " + key));
        // return true;
        // Check the key validity
        return !auth.isEmpty() && auth.get(0).equals("Bearer " + key);
    }
}
